package test.jms;

import java.util.Properties;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageConsumer;
import javax.jms.MessageListener;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class ConsumerClient {

	public static void main(String... args) throws Exception {
		InitialContext ctx = getContext("dskiles");
		
		ConnectionFactory cf = (ConnectionFactory)ctx.lookup("/ConnectionFactory");
		
		Queue pq = (Queue)ctx.lookup("queue/objectFileProcessorQueue");
		
		Connection conn = cf.createConnection();
		
		Session s = conn.createSession(false, Session.AUTO_ACKNOWLEDGE);
		
		MessageConsumer mc = s.createConsumer(pq);
		
		mc.setMessageListener(new MessageListener() {

			@Override
            public void onMessage(Message msg) {
	            try {
	                System.out.println("Message: " + ((TextMessage)msg).getText());
                } catch (JMSException e) {
	                e.printStackTrace();
                }
            }
			
		});
		conn.start();
		Thread.sleep(Integer.MAX_VALUE);
	}
	
	public static InitialContext getContext(final String host) throws NamingException {
		Properties props = new Properties();
		props.put("java.naming.factory.initial", "org.jnp.interfaces.NamingContextFactory");
		props.put("java.naming.provider.url", "jnp://" + host + ":1099");
		props.put("java.naming.factory.url.pkgs", "org.jboss.naming:org.jnp.interfaces");
		
		return new InitialContext(props);
	}
}